//	Header for Lattice dBC III Library - Description of Return Codes

#if 0

Name	    Value	Description
----------  -----	--------------------------------------------------------
SUCCESS 	0	successful function return code

d_ERROR 	1	general error code:  This error code is returned by a
			function that failed due to a fundamental reason such as
			wrong input values or the file to be accessed is not open.

d_NODBF 	2	accessed file is not organized in the data file (.DBF)
			format

d_BADREC	3	specified record number is out of range, i.e., larger
			than the current number of allocated records

d_WTFAIL	4	file-write operation failed, e.g., "disk full"

d_NONDX 	5	accessed file is not organized in the index file (.NDX)
			format

d_KYLONG	6	too long key expression

d_NOKEY 	7	index file (.NDX) is empty or requested key is not found

d_MAYBE 	8	requested key was not found in the index file, but
			another key that may immediately follow the requested
			key was located

d_ENDKEY	9	no more key exists in the index file.  the
			sequential-read key pointer is placed at the end of the
			index file

d_NOSYNC	10	key exists in the index file, but its corresponding
			record does not exist in the specified data file

d_TOPKEY	11	top of the index file condition: the sequential-read
			key pointer reached the top of the index file

#endif
