//<t>   Header File for GD Btrieve Functions

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_BTRIEVE_H_
#define _DEFD_GD_BTRIEVE_H_ 1


#define BTR_ERR     20                    /* record manager not started */
#define BTR_INT     0x7B                    /* Btrieve interrupt vector */
#define BTR2_INT    0x2F                 /* multi-user interrupt vector */
#define BTR_VECTOR  BTR_INT * 4                 /* offset for interrupt */
#define BTR_OFFSET  0x33               /* Btrieve offset within segment */
#define VARIABLE_ID 0x6176     /* id for variable length records - 'va' */
#define _2FCODE     0xAB00       /* function code for int 2F to btrieve */


int     btrv(int opCode,char posBlk[],char dataBuf[],int *dataLen,char keyBuf[],int keyNum);
BOOL    bt_mu_installed(void);


#endif  // avoid duplicate definition
