//<t>   Definitions for using dBC files

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_DB_H_
#define _DEFD_GD_DB_H_ 1


#include"dbc.h"


#define DBF_FLD_REL     struct  dbf_field_relate
DBF_FLD_REL
{
        INT16   buf_offset ;
        INT16   my_offset ;
        INT16   fld_width  ;
        BITS    l_trim : 1 ;
        BITS    r_trim : 1 ;
        BITS    add_EOS: 1 ;
//      BITS    filler :13 ;            //  fill to 16 bits
};


//      Prototypes
INT16   add_dbf_record(UCHAR **dbf_fd,UCHAR *dbf,UCHAR *rec,DBF_FLD_REL fdefs[]);
INT16   open_dbf_file(RECNUM *recs,UCHAR *dbf,UCHAR **dbf_fd);
INT16   pack_dbf_file(UCHAR *dbf_name,INT16 *dbc_error,RECNUM *orig_recs,RECNUM *copied_recs);
INT16   read_dbf_record(RECNUM num,UCHAR **dbf_fd,UCHAR *dbf,UCHAR *rec,DBF_FLD_REL fdefs[]);
INT16   recreate_ndx(UCHAR *dbf_name,UCHAR *ndx_name);
INT16   repl_dbf_record(RECNUM num,UCHAR **dbf_fd,UCHAR *dbf,UCHAR *rec,DBF_FLD_REL fdefs[]);

void    db_AT_BOX(RC row1,RC col1,RC row2,RC col2,BOOL clear);
void    db_AT_CLEAR(RC row1,RC col1,RC row2,RC col2);
void    db_AT_DOUBLE(RC row1,RC col1,RC row2,RC col2,BOOL clear);
void    db_CLEAR(void);
void    db_CLEAR_TYPEAHEAD(void);
RC      db_COL(void);
INT16   db_get_key(void);
UCHAR   db_INKEY(void);
INT16   db_key_ready(void);
INT16   db_logical_to_int(STRING str);
RC      db_ROW(void);
INT16   db_SET(INT16 set_what,INT16 set_mode,STRING set_parm);
void    db_SET_COLOR(STRING str);
INT16   db_SET_FUNCTION(UCHAR *key,UCHAR *str);
void    db_SET_FUNCTION_init(void);
void    db_SET_FUNCTION_print(void);
UCHAR * db_SET_FUNCTION_query(UCHAR *key);
int     db_Size(UCHAR *dbffd,RECNUM *size);


#endif  // avoid duplicate definition
