//<t>   General Function Prototypes for GD Library

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_FDEFS_H_
#define _DEFD_GD_FDEFS_H_ 1


STRING  st_keep_only_alnum(UCHAR s[]);
STRING  ht_char2str(UCHAR c,STRING s);
STRING  st_ptr_last_word(STRING str);
BOOL    ut_get_debug_setting(void);
STRING  fl_get_parm_from_global_ini(UCHAR data[],UCHAR section[],UCHAR varName[],UCHAR def[],BOOL ynUpcase) ;
STRING  fl_get_global_setting(UCHAR data[],UCHAR varName[],UCHAR def[],BOOL ynUpcase,UCHAR envName[]);
STRING  fl_get_pgm_def(UCHAR data[],UCHAR ev[],UCHAR def[],BOOL ynUpcase);
int     os_lastdrive(void);
int     os_windows_check(int *iMajVers,int *iMinVers);
STRING  hp_eject(void);
STRING  hp_font(STRING sFontName,STRING sFontSize,BOOL ynBold,BOOL ynItal);
STRING  hp_landscape(void);
STRING  hp_lpi(int lpi);
STRING  hp_portrait(void);
STRING  hp_reset(void);
STRING  hp_symbolset(STRING sSet);
void    show_registers(union _REGS *regsToShow);
BOOL    dr_disable_drive(UCHAR drv_letter);
BOOL    dr_enable_drive(UCHAR drv_letter);
BOOL    dr_is_floppy(UCHAR drv_number);
BOOL    dr_get_drive_parameters(UCHAR drv_number,drive_param_t *dp);
int     dr_get_drive_type(UCHAR drv_number);
UINT    ut_get_equipment_info(equipment_t *eq);
BOOL    dr_reset_floppy_controller(void);
int     dr_get_cdrom_vtoc(UCHAR drv_number,char vtoc[],unsigned int *type);
int     ut_peek (unsigned seg,unsigned off);
BYTE    ut_peekb(unsigned seg,unsigned off);
void    ut_poke (unsigned seg,unsigned off,int iVal);
void    ut_pokeb(unsigned seg,unsigned off,BYTE cVal);
UINT    ut_get_cmos_byte(UINT cmos_address);
void    ut_put_cmos_byte(UINT cmos_address,UINT cmos_value);
UINT    cmos_get_base_memory(void);
UINT    cmos_get_extended_memory(void);
void    sc_progress_exit( int iSeconds );
void    sc_progress_init( STRING sFmt, ... );
void    sc_progress( int iPct );
INT16   AbsRead(INT16 drive,UINT16 nsect,UINT16 sector,UCHAR *buffer);
void    fs_init(const BOOL bLeaveCurs,const BOOL bSW,const int iMinDOS,const STRING sV,const STRING sT,const STRING sC);
void    tt_init(const BOOL bSW,const int iMinDOS,const STRING sV,const STRING sT,const STRING sC);
//void    init_vers_tit_copr(const STRING sV,const STRING sT,const STRING sC);
BOOL    fl_datafilename(STRING fname,STRING pgmpath,STRING ext);
BOOL    fl_exist(STRING fname);
BOOL    is_shareware(void);
void    set_shareware(BOOL what);
void    st_shareware(STRING sw_topay);
STRING  st_yesno(BOOL parm);
STRING  st_YesNo(BOOL parm);
STRING  st_YESNO(BOOL parm);
int     fl_parse_ini(STRING sFile,STRING sHeader,STRING sField,STRING sContent,int *iRecNo);
void    fl_view_exit();
void    fl_view_init(int rows_to_display,int message_column,int mode,STRING title,BOOL ynSaveVideo);
int     fl_view_a_file(STRING fname,BOOL numbers);
int     fl_view(STRING fspec,BOOL numbers);
int     ut_get_option(int argc,char *argv[],char *opts);
char *  ut_get_option_arg(void);
int     ut_get_option_ind(void);
void    ut_get_option_set_error(int code);
void    (*beeper)(void);
void    AbortResume(void);                      // user-supplied fn
void    abort_msg_(INT16 ab_mode);
UINT32  AbsFnPointer(INT16(*ptr)(),ADS *pads);
UINT32  AbsPointer(UCHAR *ptr,ADS *pads);
void    Allow_Break(void);
void    Allow_No_Break(void);
void    sn_beep(void);
void    BeepSTDERR(void);
void    Binary2Str(UINT16 value,STRING dest,INT16 colons);
INT16   BIOSfunc(UINT16 cmd,UINT16 *pax,UINT16 *pbx,UINT16 *pcx,UINT16 *pdx,UINT16 *pflags);
void    BIOS_write_attr_char(UCHAR ch,ATTR attrib,INT16 howmany);
void    bload_file(STRING fname,COL cls_fg,COL cls_bg);
void    BorderColor(COL color);
void    box(COL fg,COL bg,RC trow,RC lcol,RC brow,RC rcol,BOOL fill,INT16 box_type);
INT16   BreakPressed(void);
void    bsave_file(STRING fname);
INT16   CenterBetween(INT16 start,INT16 end,STRING message);
INT16   CenterMsg(STRING message);
INT16   center_column(INT16 x);
INT16   CheckDigit_10(INT32 num,INT16 digits);
void    CheckIfAbort_(void);
void    CheckKbInterrupt(void);
void    ClearBottom(void);
void    ClearEOL(void);
void    ClearEOS(void);
void    ClearLine(RC line);
void    ClearMessage(RC row,RC col,int len);
void    ClearRect(RC u_row,RC u_col,RC b_row,RC b_col,COL fg,COL bg);
void    ClearScr3(void);
void    ClearScr_(RC row);
void    ClockSpeed(void);
void    ClockSpeed(void);
void    cls(void);
INT16   CmdLine(UCHAR *cmd_line);
STRING  color_name(COL color_code);
INT16   compare_files(UCHAR file1[],UCHAR file2[]);
void    CopyrightNotice(STRING message);
INT16   copy_file(UCHAR oldfile[],UCHAR newfile[],INT16 verify,INT16 confirm_overwrite,INT16 delete_after);
void    CouldNotOpen(STRING fname,STRING mode);
UINT16  crc_calc(UINT16 crcval,UCHAR crc_char);
UINT16  crc_of_crc(UINT16 crc);
void    credits(STRING msg);
void    CryptKey(UCHAR key[]);
void    CryptStr(UCHAR *in,UCHAR *out,UCHAR key[]);
INT16   CurrentDrive(void);
INT16   CurrentPath(STRING pdir);
INT16   CurrPathDrive(INT16 drive,STRING pdir);
void    CursOff(void);
void    CursOn(void);
void    CursOnBox(void);
void    CursOnInsert(void);
INT16   CursorEmulation(INT16 parm);
BOOL    CursorSize(BOOL off,INT16 top,INT16 bottom);
void    CursorUp(RC no_of_lines);
UINT16  Date2Fstamp(INT16 year,INT16 month,INT16 day);
INT32   Date2Num(INT32 ymd);
INT16   DateSplit(INT32 indate,INT16 *yyyy,INT16 *mm,INT16 *dd);
INT32   DateStr2ymd(UCHAR sdate[],INT16 dtyp);
STRING  DayName(INT16 day);
INT32   DaysBetween(INT32 date1,INT32 date2);
INT16   DaysInMonth(INT32 ymd);
INT32   dbl_2_long(double dbl_num,INT16 dec,INT16 round);
double  dbl_round(double dbl_num,INT16 dec);
void    debug_display(void);
INT16   decode_serial(STRING ser_str,STRING decoded_ser);
INT16   DelayKbd(INT16 secs,INT16 flush,INT16 keys);
void    DelaySecs(INT16 seconds);
void    DelayTics(INT32 tics);
UINT32  DiskSpace(INT16 *drive,UINT16 *p_av_clus,UINT32 *p_to_clus,UINT16 *p_sect_size,UINT16 *p_clus_size,UINT32 *p_tbytes);
int     dll_create_entry(STRING data);
int     dll_create_sorted(STRING data);
void    dll_init_list(void);
STRING  dll_picklist(RC mnuwid,RC lines_on_scr,STRING title,char *pickerhelp[]);
void    dll_picklist_init(RC mnuwid,RC lines_on_scr,STRING title);
void    dll_print_list(void);
void    dll_remove_list(void);
INT16   DOSfunc(INT16 fn,INT16 dxval);
INT16   DOSfunction(DOSREG *preg);
int     DOS_version_check(int low_ver);
void    DOS_version_enforce(int low_ver);
INT16   dr_expand_path(UCHAR *inpath,UCHAR *drive,UCHAR *dir,UCHAR *fname,UCHAR *ext);
BOOL    dr_is_cdrom(UCHAR drv_number);
BOOL    dr_is_directory(STRING pathname);
BOOL    dr_is_networked(UCHAR drv_number);
BOOL    dr_is_remote(UCHAR drive_letter);
BOOL    dr_is_removable(UCHAR drv_number);
BOOL    dr_is_subst(UCHAR drv,STRING real_path);
BOOL    dr_mkdir(STRING dirname,BOOL go_there);
STRING  dr_q_fname(STRING infile);
STRING  dr_remove_trailer_from_path(UCHAR path[]);
int     dr_type(UCHAR c);
INT16   dr_valid_path(UCHAR fullspec[],UCHAR path_out[],UCHAR rest_out[]);
void    DspCh(RC row,RC col,COL fg_color,COL bg_color,UCHAR ch,INT16 howmany);
void    DspChar(INT16 fg_color,INT16 bg_color,UCHAR ch,INT16 howmany);
void    DspMessage(RC row,RC col,COL fg,COL bg,STRING fmt,...);
void    DspMsg(RC row,RC col,COL fg,COL bg,UCHAR msg[],BOOL upd_cursor);
void    DspSysDate(void);
void    DspSysTime(void);
void    dsp_logo(void);
int     ds_avail_drives(UCHAR drives[]);
ULONG   ds_clustersize(UCHAR drive);
int     ds_create_label(UCHAR drive,UCHAR label[]);
BOOL    ds_get_media_info(UCHAR drive,STRING label,STRING serial,STRING fsystem);
BOOL    ds_get_serial_number(UCHAR drive,UCHAR serial[]);
BOOL    ds_ready(UCHAR drive);
int     ds_remove_label(UCHAR drive);
BOOL    ds_set_media_info(UCHAR drive,STRING label,STRING serial,STRING fsystem);
BOOL    ds_set_serial_number(UCHAR drive,UCHAR serial[]);
BOOL    ds_set_volume_label(UCHAR drive,STRING label);
BOOL    ds_vol_label(STRING given_drive,STRING vl_drive,UCHAR vl_label[],INT32 *vl_date,INT32 *vl_time);
int     dt_dow(int dd,int mm,int yy);
int     dt_easter(int year);
INT16   dt_format_size(INT16 outfmt);
INT16   dt_getsystemdate(INT32 *yyyymmdd,INT16 *yyyy,INT16 *mm,INT16 *dd);
int     dt_weeknumber(INT32 ymd);
INT32   dt_ymd(int dd,int mm,int yy);
void    EGAborder(COL color);
void    EGA_43(void);
void    EGA_Wonder_C_132x25(void);
void    EGA_Wonder_C_132x44(void);
void    EGA_Wonder_M_132x25(void);
void    EGA_Wonder_M_132x44(void);
INT16   EnterNumber(FLAG dis,RC row,RC col,COL fg,COL bg,INT len,INT dec,BOOL reqd,BOOL hold,BOOL a_esc,BOOL a_fk,BOOL a_cfk,BOOL a_sfk,BOOL a_afk,UCHAR data[],UCHAR low[],UCHAR high[],UCHAR help[]);
INT16   EnterText(STRING reply,INT16 leng,INT16 ctrl,INT16 abort_key,STRING prompt,...);
void    ErrMsg(STRING msg,...);
INT16   ExtractFileExt(STRING dest,STRING in_str,BOOL make_upper);
void    fader(void);
void    fade_out(COL fg,COL bg,BOOL sounds);
UINT16  FATvalue(INT16 is12,UINT16 cluster,UCHAR fat[]);
INT16   FindFileInPath(STRING FoundWhere,STRING FileName);
void    Finished(void);                         // user-supplied fn
INT16   flretdta(ADS *pdta_ads);
INT16   flsetdta(ADS *pdta_ads);
void    FlushKeyboard(void);
int     fl_create_extfcb(e_fcb_t *fcb);
FILE *  fl_create_or_replace_tty(FILE *fHandle,const STRING fName,const STRING fOpenMode,const BOOL abort_on_error,BOOL verbose);
INT16   fl_delete(STRING f_name);
int     fl_delete_extfcb(e_fcb_t *fcb);
INT16   fl_read1(int fh,UCHAR dest[],INT16 maxchar,INT16 *endfile);
INT16   fl_rename(STRING old_file,STRING new_file);
INT16   fl_split_path(STRING PathName,STRING FileSpec);
STRING  fl_translate_name(STRING name);
STRING  fmt_adr(void *object,STRING out);
INT16   ForceRangeI16(INT16 test_item,INT16 lower_limit,INT16 upper_limit);
INT16   FormatDate(INT32 indate,STRING pdest,INT16 outfmt);
INT16   FormatTime(INT32 tm_in,UCHAR *dest,INT16 infmt,INT16 outfmt);
STRING  Format_INT16(INT16 num,STRING dest);
STRING  Format_INT32(INT32 num,STRING dest);
STRING  Format_UINT16(UINT16 num,STRING dest);
STRING  Format_UINT32(UINT32 num,STRING dest);
INT16   Fstamp2date(UINT16 fdate,INT16 *pyear,INT16 *pmonth,INT16 *pday);
INT16   Fstamp2time(UINT16 ftime,INT16 *phour,INT16 *pminute,INT16 *psecond);
void    gd_exit(INT16 exitcode,STRING msg);
void    gd_init(BOOL leave_cursor);
void    gd_not_init(void);
INT16   GetAttrib(UCHAR *fpath,INT16 *at_ro,INT16 *at_hidden,INT16 *at_system,INT16 *at_vol,INT16 *at_dir,INT16 *at_arch);
INT16   GetBits(UINT16 wrd,UINT16 pos,UINT16 num);
INT16   GetClusterSize(INT16 drive);
INT16   GetCrEsc(INT16 flush);
INT16   GetCursorSize(INT16 *low,INT16 *high);
struct disk_table FAR * GetDiskTablePtr(INT16 drv);
UCHAR   GetDrive(void);
UINT16  GetDSregister(void);
STRING  GetEnvPar(STRING str);
INT16   GetFileInfo(FILE *fptr,UINT32 *pfdate,UINT32 *pftime);
INT16   GetFreeDiskSpace(INT16 drive,UINT16 *avail,UINT16 *total,UINT16 *sectsize);
INT16   GetLine(STRING s,INT16 maxchar,INT16 flush,INT16 *endfile);
INT16   GetStr(STRING s,INT16 maxchar,UCHAR ender,INT16 *endfile);
INT16   GetStrF(STRING s,INT16 maxchar,UCHAR ender,INT16 *endfile);
INT32   GetTics(void);
INT16   GetVideoMode(INT16 *pmode,INT16 *pcolumns,INT16 *papage);
STRING  get_global_program_name(void);
int     Glb_delenv(char FAR *Env,unsigned EnvSize,char FAR *name);
char FAR * Glb_getenv(char FAR *Env,char FAR *name);
void    Glb_locate_env(char FAR **Env,unsigned *EnvSize);
int     Glb_putenv(char FAR *Env,unsigned EnvSize,char FAR *name);
void    Glissando(int lower,int upper,int rate);
INT16   GrComDenom(INT16 x,INT16 y);
void    gr_bg_color(INT16 bg);
void    gr_box(INT16 x1,INT16 y1,INT16 x2,INT16 y2);
void    gr_box_filled(INT16 x1,INT16 y1,INT16 x2,INT16 y2);
void    gr_clip(INT16 turn_on,INT16 x1,INT16 y1,INT16 x2,INT16 y2);
void    gr_fg_color(INT16 fg);
INT16   gr_init(INT16 res,INT16 palette,INT16 backgrd,INT16 fg);
void    gr_line(INT16 x1,INT16 y1,INT16 x2,INT16 y2);
void    gr_line_c(INT16 x_start,INT16 y_start,INT16 x_end,INT16 y_end,INT16 color);
void    gr_move_abs(INT16 to_pos_x,INT16 to_pos_y);
void    gr_move_rel(INT16 deltax,INT16 deltay);
INT16   gr_PrtSc(void);
void    gr_putchar(INT16 x,INT16 y,UCHAR c);
void    gr_puts(INT16 x,INT16 y,STRING s);
INT16   gr_rd_dot(INT16 x,INT16 y);
void    gr_showvideoconfig(struct _videoconfig FAR *vc);
void    gr_text(RC row,RC col,STRING msg);
void    gr_text_flipped(RC row,RC col,STRING msg,FLAG which_way);
void    gr_text_flip_left(RC row,RC col,STRING msg);
void    gr_text_upside_down(RC row,RC col,STRING msg);
void    gr_text_vert(RC row,RC col,STRING msg);
INT16   gr_what_bg(void);
INT16   gr_what_fg(void);
void    gr_wr_dot(INT16 x,INT16 y);
void    gr_wr_dot_c(INT16 x,INT16 y,INT16 color);
void    HangTheSystem(void);
void    HelpMsg(UCHAR *msg,...);
INT16   HoldMsg(INT16 esc,INT16 flush);
UCHAR * I2sPosInt(INT32 li,INT16 count,STRING dest,INT16 commas);
INT16   InitDOSreg(struct dreg *preg);
void    InitMenu(void);
void    init_pr_def_str(void);
INT16   InKey(INT16 *pscan);
INT16   InRange(INT16 test_item,INT16 lower_limit,INT16 upper_limit);
void    Int2Str(INT16 value,STRING dest,INT16 sign,INT16 commas,INT16 f_width,INT16 z_fill);
void    Internal_Error(INT16 ecode);
INT16   IsBitSet(INT16 n,INT16 wrd);
INT16   IsLeapYear(INT16 year);
INT16   is_EGA(void);
INT16   Is_Even(INT16 num);
BOOL    is_installed(INT16 mplex_code);
INT16   Is_Odd(INT16 num);
INT16   is_VGA(void);
void    i_sort(char *pa[],int na);
INT32   Jul2Date(INT32 num);
INT16   JulianDay(INT32 ymd);
BOOL    list_file(STRING fname);
void    list_files(STRING fspec);
INT32   ll_calib(void);
RC      LocateCursor(RC *row,RC *col);
void    logon(BOOL force);
void    log_wr(INT16 msg_type,INT16 msg_err,BOOL dump_scr,STRING msg);
void    Long2Str(INT32 value,STRING dest,INT16 sign,INT16 commas,INT16 f_width,INT16 z_fill);
INT16   MapLong2Str(INT32 lnum,UCHAR str[],INT16 bytes);
FLAG    modem_init(INT16 type);
INT16   Month2Number(UCHAR mth[]);
void    MoveCursor(RC row,RC col);
INT16   MoveMemory(ADS *psource,ADS *ptarget,UINT16 nbytes);
int     MSCDEX_cdrom_drives(UCHAR *start_drive);
BOOL    MSCDEX_installed(void);
int     MSCDEX_version(int *major,int *minor);
void    MSdate2text(ms_date_t date,STRING s);
void    MStime2text(ms_time_t time,STRING result);
STRING  mth_name_(INT16 n);
void    name_of_pr_def_file(STRING cfg_file_name);
INT32   NewDate(INT32 ymd,INT16 factor,INT16 addsub);
void    NewScreen(void);
void    nextday(int *dd,int *mm,int *yy);
int     null_error(void);
INT32   Num2Date(INT32 num);
UCHAR   NybbleHigh(UCHAR ch);
UCHAR   NybbleLow(UCHAR ch);
UCHAR   Nybbles2Byte(UCHAR hi,UCHAR lo);
INT16   ParseFileName(STRING filename,e_fcb_t *fcb,INT16 mode);
INT16   path_pr_def_file(STRING name,STRING path);
INT16   PicAmount(INT32 number,UCHAR dest[],UCHAR picture[]);
INT16   PopCursor(void);
INT16   PopPath(void);
INT16   pop_i16(void);
INT32   pop_i32(void);
UCHAR * pop_str(UCHAR *s);
UCHAR   pop_uchar(void);
void    PrintScreen(void);
STRING  program_name(STRING pname,STRING pathonly,STRING fullpath);
INT16   pr_Char(UCHAR ch);
INT16   pr_char_(UCHAR ch);
INT16   pr_Codes(STRING s,INT16 n);
BOOL    pr_dos(STRING prt_line,...);
void    pr_dos_char(UCHAR ch);
BOOL    pr_dos_close_printer(void);
void    pr_dos_codes(STRING s,INT16 n);
BOOL    pr_dos_open_printer(void);
STRING  pr_dos_printer_name(void);
void    pr_dos_string(STRING s);
BOOL    pr_dos_w_xlate(STRING str);
INT16   pr_Graphics(INT16 density,INT16 length,UCHAR *bit_table);
INT16   pr_Header(INT16 page_width,INT16 *page_num,UCHAR *title,UCHAR *rh_line_1,UCHAR *rh_line_2,INT16 space_before,INT16 space_after);
void    pr_lpt_(INT16 number);
void    pr_mode_(INT16 mode);
INT16   pr_ok_(void);
void    pr_reset_(INT16 number);
INT16   pr_SetupPrint(STRING str);
BOOL    pr_SetupXlate(STRING string_in,STRING string_out,INT16 *count);
INT16   pr_status_(void);
INT16   pr_String(STRING s);
void    pull_menu_entry(BOOL turn_on,UCHAR *choice,UCHAR *msg,RC posn,RC line,RC help_line);
INT16   PushCursor(void);
INT16   PushPath(void);
INT16   push_i16(INT16 i);
INT16   push_i32(INT32 i);
INT16   push_str(UCHAR *s);
INT16   push_uchar(UCHAR c);
void    putpt_CGA_320_200(INT16 col,INT16 row,UCHAR color);
void    putpt_CGA_640_200(INT16 col,INT16 row,UCHAR color);
void    PutString(STRING str);
int     QCheck(void);
INT16   RandomNumber(INT16 lower,INT16 upper);
void    RandomSeed(void);
ULONG   random_ULONG(ULONG lower,ULONG upper);
INT16   ReadBinFromFile(FILE *fdin,INT16 howmany,UCHAR *buffer,INT16 *endfile);
INT16   ReadLine(FILE *fhand,UCHAR *dest,INT16 maxchar,INT16 flush,INT16 *endfile);
void    ReadSegReg(UINT16 *pcs,UINT16 *pss,UINT16 *pds,UINT16 *pes);
INT16   read_pr_def_file(void);
void    Reboot(UCHAR which);
void    RedAlert(void);
INT16   ResetVideo(INT16 mode);
UCHAR * RestoreLine(INT16 line_number,UCHAR *buffer);
UCHAR * RestoreScreen(UCHAR *buffer);
void    sc_restore_video_state(void);
UCHAR * SaveLine(INT16 line_number,UCHAR *buffer);
UCHAR * SaveScreen(UCHAR *buffer);
void    sc_save_video_state(void);
INT32   ScaleINT32(STRING in_str,INT16 dec);
INT16   ScBlockAttr(RC row1,RC col1,RC row2,RC col2,COL fg,COL bg);
void    ScBlockRead(UCHAR *block,RC row1,RC col1,RC row2,RC col2);
void    ScBlockWrite(UCHAR *block,RC row1,RC col1,RC row2,RC col2);
INT16   Scr2Disk(void);
UCHAR   ScRead(COL *pfore,COL *pback);
UCHAR   ScreenAttrib(INT16 fg,INT16 bg);
INT16   ScrollHoriz(RC ncols,ATTR attr,RC l_row,RC l_col,RC r_row,RC r_col,FLAG dir);
void    sc_blanker(void);
INT16   sc_blanker_delay(INT32 secs);
void    sc_box_explode(COL fg,COL bg,RC trow,RC lcol,RC brow,RC rcol,INT16 box_type);
void    sc_shadow_box(RC trow,RC lcol,RC brow,RC rcol,INT16 box_type);
void    sc_centered(RC row,COL fg,COL bg,STRING fmt,...);
RC      sc_col(void);
void    sc_color_default(void);
void    sc_color_default_reset(INT16 fg,INT16 bg);
void    sc_cursor_off(void);
void    sc_cursor_on(void);
void    sc_get_cursor_scanlines(int *start,int *end);
void    sc_help_screen(char *help[]);
INT16   sc_menu_choice(INT16 initial_resp,UCHAR **resp_str);
INT16   sc_menu_init(RC row,RC col,INT16 type,STRING title,INT16 boxtype,BOOL res_after,BOOL auto_ret);
FLAG    sc_menu_item(RC row,RC col,STRING prompt,STRING msg);
void    sc_message_line(RC row,BOOL center);
void    sc_msg(STRING fmt,...);
void    sc_msg_at(RC row,RC col,STRING fmt,...);
void    sc_offset(INT16 offset);
void    sc_rd_rect(RC u_row,RC u_col,RC l_row,RC l_col,UCHAR buffer[]);
void    sc_rd_rect_BIOS(RC row1,RC col1,RC row2,RC col2,UCHAR *where);
INT16   sc_rev_attr(RC row1,RC col1,RC row2,RC col2);
RC      sc_row(void);

FLAG    sc_read_video_cfg(void);
FLAG    sc_save_video_cfg(void);

void    sc_scroll(RC no_lines,ATTR attr,RC u_row,RC u_col,RC l_row,RC l_col,FLAG dir);
void    sc_val_rect(RC *u_row,RC *u_col,RC *l_row,RC *l_col);

int     sc_vid_cols(void);
int     sc_vid_rows(void);

void    sc_wr_char(UCHAR ch);
void    sc_wr_chars(UCHAR ch,INT16 cnt);
void    sc_wr_rect(RC u_row,RC u_col,RC l_row,RC l_col,UCHAR buffer[]);
void    sc_wr_rect_BIOS(RC row1,RC col1,RC row2,RC col2,UCHAR *where);
int     SearchFirstFile(e_fcb_t *fcb);
int     SearchNextFile(e_fcb_t *fcb);
INT16   SelectDrive(INT16 drive);
INT16   ser_port_aborted(void);
INT16   ser_port_getch(UCHAR *c);
INT16   ser_port_init(INT16 port,UINT16 baud,INT16 parity,INT16 d_bits,INT16 s_bits,INT16 local_echo);
INT16   ser_port_putbuf(UCHAR *b,INT16 n);
INT16   ser_port_putch(UCHAR c);
INT16   ser_port_puts(UCHAR *s);
UINT16  ser_port_status(void);
INT16   SetActPage(INT16 page);
INT16   SetAttrib(STRING fpath,INT16 set_ro,INT16 set_hidden,INT16 set_system,INT16 set_arch);
void    SetBorder(void);
INT16   SetCurrPage(INT16 page);
INT16   SetDrive(UCHAR letter);
INT16   SetDTA(UCHAR *buffer);
INT16   SetFileInfo(FILE *fptr,UINT32 fdate,UINT32 ftime);
INT16   SetGlobalString(const INT16 cWhich,const STRING cContent);
void    SetMenuAuto(INT16 which);
void    SetMenuTitle(STRING title);
INT16   SetSysDate(INT32 yyyymmdd);
INT16   SetSysTime(INT32 hhmmss);
INT16   set_color(INT16 which,COL fg,COL bg);
void    set_default_colors(void);
void    set_fstamp_format(INT16 format);
void    set_global_program_name(void);
INT16   ShowMenu(INT16 menu_type,UCHAR *menu_options[],BOOL clear_after,RC row,RC column,INT16 *init_choice);
INT16   sign_of(INT16 number);
void    slash_menu_entry(BOOL turn_on,UCHAR *choice,UCHAR *msg,RC posn);
INT16   Soundex(STRING soundex,STRING in_string);
void    SoundFatalE(void);
void    SoundGun(void);
void    SoundMinorE(void);
void    SoundPrompt(void);
void    SoundSuccess(void);
INT16   SplitArgument(UCHAR *arg_input,UCHAR brk_char,UCHAR *parm,INT16 parm_len,UCHAR *swit,INT16 *num);
INT16   SplitString(STRING s_in,STRING brk,STRING s1_out,STRING s2_out);
void    stack_err_msg(STRING fn_name,FLAG over_under);
void    startup_scr_stub__(void);
void    startup_tty_stub__(void);
void    startup_scr(void);
void    startup_tty(void);
void    StatusMsg(STRING msg,...);
INT16   Str2Int(STRING s);
INT32   Str2Long(STRING sl);
INT16   StrCatChar(STRING dest,UCHAR ch,INT16 maxchar);
INT16   StrCatChars(STRING dest,UCHAR ch,INT16 howmany,INT16 maxchar);
STRING  StrConv(STRING psource,int conv);
INT16   StrCount(UCHAR chr,STRING str,INT16 ignore_case);
INT16   StrCountDec(INT16 *before,INT16 *after,STRING str);
STRING  StrDelChar(STRING s,UCHAR c);
STRING  StrDetab(STRING dest,STRING src,INT16 maxchar);
INT16   StrELeft(STRING dest,STRING psource,INT16 cnt,INT16 tarsize);
INT16   StrEq(STRING s1,STRING s2);
INT16   StrERight(STRING str_to,STRING str_from,INT16 posn,INT16 maxsize);
void    StrFill(UCHAR dest[],UCHAR ch,register INT16 maxchar);
INT16   StrFindChar(UCHAR check_char,UCHAR *str);
INT16   StrFindString(UCHAR check[],UCHAR to_search[],INT16 ignore);
INT16   StrInsert(UCHAR dest[],UCHAR src[],INT16 posn,INT16 maxchar);
INT16   StrLegal(UCHAR *str,UCHAR *legal_chars);
INT16   StrLookupWrap(INT16 ch,UCHAR letters[],INT16 start);
INT16   st_lookup_wrap(INT16 ch,UCHAR letters[],INT16 start);
INT16   StrMapDec(UCHAR dest[],UCHAR orig_src[],INT16 before,INT16 after,INT16 maxlen);
INT16   StrNotEq(STRING s1,STRING s2);
INT16   StrOverlay(STRING dest,STRING src,INT16 start);
INT16   StrR(STRING str_to,STRING str_from,INT16 howmany);
INT16   StrSDate(STRING pdate,INT16 *pyear,INT16 *pmonth,INT16 *pday);
INT16   StrShift(UCHAR str[],INT16 direc,INT16 howmany,UCHAR fillchar);
INT16   StrSTime(UCHAR *ptime,INT16 *phours,INT16 *pminutes,INT16 *pseconds,INT16 *ptics);
STRING  st_cat(UCHAR dest[],UCHAR src[],INT16 maxchar);
INT16   st_ch_index(UCHAR ch,UCHAR *str);
STRING  st_cpy(UCHAR dest[],UCHAR src[],INT16 maxchar);
BOOL    st_eq(STRING s1,STRING s2);
void    st_get_env_var(const STRING pTarget,STRING pDest,const int szDest,const STRING pDefault,const BOOL ynUpcase);
STRING  st_get_word(STRING dest,STRING str);
STRING  st_left(UCHAR *dest,UCHAR *src,INT16 cnt,INT16 maxdest);
INT16   st_len(UCHAR str[]);
long    st_len_word(STRING str);
void    st_ltrim(STRING string);
STRING  st_reduce_spaces(STRING s);
STRING  st_remove_spaces(UCHAR s[]);
STRING  st_remove_word(STRING str);
void    st_rtrim(STRING string);
void    st_trim(STRING string);
STRING  st_uplow(STRING str);
STRING  st_xlate(UCHAR *str,UCHAR *chk_table,UCHAR *xlt_table);
INT16   SubStr(STRING dest,STRING src,INT16 posn,INT16 maxchar);
void    SwapDbl(double *dbl_1,double *dbl_2);
void    SwapInt16(INT16 *i1,INT16 *i2);
void    SwapInt32(INT32 *i1,INT32 *i2);
int     sys_command(char *cmd);
INT16   tabstop(INT16 column,INT16 tabwidth);
UINT16  Time2Fstamp(INT16 hour,INT16 minute,INT16 second);
INT16   TimedOut(void);
void    TimerInit(long hsecs);
INT16   TimeSplit(INT32 intime,INT16 *hh,INT16 *mm,INT16 *ss);
INT16   TimeStr2Num(UCHAR str[],INT16 fmt,UINT32 *num);
INT16   tm_minutes_2_str(INT32 iTime,STRING szTime,INT16 iFormat);
INT32   tm_str_2_minutes(STRING szTime);
INT16   tm_getsystemtime(INT32 *hhmmsstt,INT32 *tics,INT16 *hh,INT16 *mm,INT16 *ss,INT16 *tt);
long    tm_get_ticks(void);
void    tm_sleep_ticks(int wait);
void    tm_sleep_msecs(clock_t wait);
void    tm_sleep_secs(int secs);
STRING  TodaysCDate(void);
STRING  TodaysDate(void);
STRING  TodaysDay(void);
STRING  TodaysTime(void);
void    Tone(int frequency,int duration);
int     ToneFreq(int frequency);
void    ToneInit(void);
void    ToneOff(void);
void    ToneOn(void);
void    ToneSet(int sq_freq);
int     truename(char *filename);
void    tty_char(UCHAR ch,COL fg,COL bg);
void    tty_msg(STRING str,COL fg,COL bg);
void    tty_msg_buf_flush_(STRING str,COL fg,COL bg);
void    tty_print(UCHAR *fmt,...);
void    tty_printf(COL fg,COL bg,STRING fmt,...);
int     unpack_archive(STRING arc,STRING where,UINT32 file_date,UINT32 file_time);
void    ut_err_msg(STRING funcname,STRING ms1,STRING ms2);
BOOL    ValidDate(INT32 ymd);
BOOL    ValidDrive(int drive);
BOOL    valid_drive(UCHAR drive);
UINT16  ValueOfBit(INT16 num);
INT16   VideoModeRefresh(void);
RC      VideoRows(void);
INT16   VideoScanLines(void);
void    virus_check(char *pgm);
int     virus_check_pgm(char *pgm);
void    WaitMsg(void);
void    WarningMsg(STRING msg,...);
INT16   WhatDay(INT32 indate,UCHAR *pdest,INT16 outfmt);
INT16   WhatWeek(INT32 this_day,INT32 *Sunday_date,INT32 *Saturday_date);
void    WhiteNoise(int lower,int upper,int duration);
INT16   WriteBinToFile(FILE *fd_out,INT16 howmany,UCHAR *buffer);
INT16   write_pr_def_file(void);
INT16   YesNo(STRING msg,INT16 deflt_resp,INT16 wait);
INT16   YesOrNo(STRING msg,INT16 deflt_resp,INT16 wait);


#endif  // avoid duplicate definition
