//<t>   Prototypes and definitions for Microsoft compatible mouse functions

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_MOUSE_H_
#define _DEFD_GD_MOUSE_H_ 1


#define MOUSE_FUNC      0x33
#define MOUSE_REGS      union _REGS r
#define CALL_MOUSE(fun) r.x.ax=fun; _int86(MOUSE_FUNC,&r,&r)


//      Prototypes
void    ms_button_press(int button,int *bstat,int *bcount,int *x,int *y);
void    ms_button_release(int button,int *bstat,int *bcount,int *x,int *y);
BOOL    ms_check_button(int which);
void    ms_cursor_mode(int curtype,int smask,int cmask);
void    ms_goto(RC row,RC col);
void    ms_goto_xy(int x,int y);
void    ms_hide_cursor(void);
void    ms_hor_bounds(int left,int right);
int     ms_init(void);
void    ms_locate_text_cursor(RC *row,RC *col);
void    ms_motion(int *xcount,int *ycount);
void    ms_reset(void);
void    ms_show_cursor(void);
void    ms_speed(int xratio,int yratio);
void    ms_status(int *bstat,int *x,int *y);
void    ms_vert_bounds(int top,int bottom);


extern  BOOL    mouse_installed_ ;


extern  void    (*mouse_reset_)(void);
extern  BOOL    (*mouse_chk_button_)(int);
extern  void    (*mouse_locate_tcursor_)(RC *,RC *);


#endif  // avoid duplicate definition
