@echo off
 goto begin

.doc
 .Pur Compile C/C++ programs
 .Aut Gerry J Danen
 .Mod 03-Apr-96
 .Syn CC [sourcefile]
 .Hlp
 .Not
.enddoc

:begin
 rem    Make sure certain evars are available
 if []==[%ramdrv%] set ramdrv=C:
 if []==[%ram%] set ram=%ramdrv%\

 set LINK=/NOLOGO/ONERROR:NOEXE
 set gd.sound=on
 call home_drv
 mkpath %ramdrv%\work
 %HOM_DRV_%
 if (%1)==() goto noparm
 set CC.GROUP=
 set CC.FILE=%1
 shift

:noparm
 if ()==(%CC.FILE%) goto nofile
 set cc.ext=.cpp
 if exist %CC.FILE%.c set cc.ext=.c
 bu h Compiling %HOM_DRV_%%CC.FILE%%cc.ext% (Memory Model %CMODEL%) [x:cc.bat]

 rem for CodeView:
 rem CL=/Zp /Ze /Zl /A%CMODEL% /c /%CC_WARNLVL% /Od /Zi /Zd

 set CL=/A%CMODEL% /c /Gf /Ox /%CC_WARNLVL% /Ze /Zl /Zp
 : set CC_LIB=%CMODEL%LIBCE+TL_A_%CMODEL%+TL_C_%CMODEL%+DB_C_%CMODEL%+C_PSMS_%CMODEL%+NWCALLS%CMODEL%
 set CC_LIB=%CMODEL%LIBCE+TL_A_%CMODEL%+TL_C_%CMODEL%+DB_C_%CMODEL%+%CMODEL%NIT+NWCALLS%CMODEL%

 rem Set up "goback.bat" and "errback.bat"
 cdpath >%ram%goback.bat
 echo if not exist %RAMDRV%%CC.FILE%.exe goto done >>%ram%goback.bat
 echo echo Old file:>>%ram%goback.bat
 echo tdir %CC.FILE%.exe   >>%ram%goback.bat
 echo echo New file:>>%ram%goback.bat
 echo tdir %RAMDRV%%CC.FILE%.*   >>%ram%goback.bat
 echo copy  %RAMDRV%%CC.FILE%.exe %CC.FILE%.exe >>%ram%goback.bat
 echo erase %RAMDRV%%CC.FILE%.* >>%ram%goback.bat
 rem  erase %DRV_DEV_C%\lib\%CC.FILE%.exe >>%ram%goback.bat
 rem  erase %DRV_DEV_C%\lib\%CC.FILE%.obj >>%ram%goback.bat
 echo if exist %RAMDRV%*.obj erase %RAMDRV%*.obj >>%ram%goback.bat
 echo :done>>%ram%goback.bat
 echo new  %RAM%l >>%ram%goback.bat
 echo echo ----------------------------------------------------------------------------->>%ram%goback.bat
 echo type %RAM%l >>%ram%goback.bat
 cdpath >%ram%errback.bat
 echo cc_err %HOM_DRV_%%CC.FILE%%cc.ext% %RAM%l %RAM%cc.err >>%ram%errback.bat
 echo e %RAM%cc.err >>%ram%errback.bat

 tdir %CC.FILE%.*
 %RAMDRV%
 mk \work
 if "%CMODEL%"=="S" bu m [0;47;31m Small Memory Model [0;44;37m
 if "%CMODEL%"=="L" bu m [0;47;35m Large Memory Model [0;44;37m
 if "%CMODEL%"=="C" bu m [0;47;31m Compact Memory Model [0;44;37m
 cl %HOM_DRV_%%CC.FILE%%cc.ext% >%RAM%l
 if errorlevel 1 goto cerr
 cd %CLIB%
 : if not exist TL_A_S.lib copy %clib%\TL_*.lib %RAMDRV% >nul
 echo %CC.FILE% /SE:160 /M/NOI/NOE/NOD /ST:9000 %1%2%3%4%5 >resp.lnk
 echo %CC.FILE% >>resp.lnk
 echo l.map     >>resp.lnk
 echo oldnames+graphics+%CC_LIB%; >>resp.lnk
 type %RAM%l
 echo Linking
 LINK @resp.lnk >>%RAM%l
 if errorlevel 1 goto lnkerr
 clog %CMODEL% %CC.FILE% exe %CLIB%\compile.log
 pklite -e- %CC.FILE% >>%RAM%l
 goto done

:cerr
 bu s
 bu m Compile errors
 %ram%errback

:lnkerr
 bu s
 bu m Link errors
 %ram%errback

:done
 %ram%goback

:nofile
 bu m Compile what?
 bu s ?
