//<t>   Header file for Bar Code functions

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_BAR_H_
#define _DEFD_GD_BAR_H_ 1


int     barsize(int bar_type,Byte *bar_str,Byte *bar_txt,int prt_type,
                int lmgn,int height,Boolean chksum,int passes);
int     bar_code(Byte *ret_string,int bar_type,Byte *string,Byte *text,
                 int printnum,int offset,int height,Boolean chksum,int passes);
//      Parameters:
//              ret_string      array of characters to store code to
//              bar_type        bar code type
//              bar_str         the character string to bar code
//              bar_txt         the character string to print under bar
//              prt_type        the printer type
//              lmgn            number of characters from left margin
//              height          bar code height in 1/10 inch units
//              chksum          whether to print checksum when optional
//              passes          number of overstrike passes to print (density)
//      Returns:
//              length          size of output string

int     CM_generate(Byte *ret_string,int bar_type,Byte *string,Byte *text,
                    struct code *codes,int offset,int height,Boolean chksum,
                    int passes);

#endif  // avoid duplicate definition
