//<t>   Header File for the Graphics Functions of GD TOOLS

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_GRAPH_H_
#define _DEFD_GD_GRAPH_H_ 1


#define CGA_320_200_COL 4
#define CGA_320_200_BW  5
#define CGA_640_200_BW  6
#define EGA_320_200_COL 13
#define EGA_640_200_COL 14
#define EGA_640_350_MON 15
#define EGA_640_350_COL 16


//      Graphics print densities

#define PR_SINGLE_DENS  480
#define PR_DOUBLE_DENS  960
#define PR_DOUBLE_FAST  961
#define PR_QUAD_DENS    1920


extern  INT16   gr_home_x, gr_home_y ;          //  home coordinates
extern  INT16   gr_max_x,  gr_max_y ;           //  (max+1) values for x, y
extern  COL     gr_fg_color_, gr_bg_color_ ;    //  global colors
extern  UCHAR   FAR_MEM gr_font_std[] ;         //  standard font 8x8


// void    gr_bg_color(INT16 bg);
// void    gr_box(INT16 x1,INT16 y1,INT16 x2,INT16 y2);
// void    gr_box_filled(INT16 x1,INT16 y1,INT16 x2,INT16 y2);
// void    gr_clip(INT16 turn_on,INT16 x1,INT16 y1,INT16 x2,INT16 y2);
// void    gr_fg_color(INT16 fg);
// INT16   gr_init(INT16 res,INT16 palette,INT16 backgrd,INT16 fg);
// void    gr_line(INT16 x1,INT16 y1,INT16 x2,INT16 y2);
// void    gr_line_c(INT16 x_start,INT16 y_start,INT16 x_end,INT16 y_end,INT16 color);
// void    gr_move_abs(INT16 to_pos_x,INT16 to_pos_y);
// void    gr_move_rel(INT16 deltax,INT16 deltay);
// INT16   gr_PrtSc(void);
// void    gr_putchar(INT16 x,INT16 y,UCHAR c);
// void    gr_puts(INT16 x,INT16 y,STRING s);
// INT16   gr_rd_dot(INT16 x,INT16 y);
// void    gr_showvideoconfig(struct videoconfig FAR *vc);
// void    gr_text(INT16 row,INT16 col,STRING msg);
// void    gr_text_flipped(INT16 row,INT16 col,UCHAR *msg,INT16 which_way);
// void    gr_text_flip_left(INT16 row,INT16 col,UCHAR *msg);
// void    gr_text_upside_down(INT16 row,INT16 col,UCHAR *msg);
// void    gr_text_vert(INT16 row,INT16 col,UCHAR *msg);
// INT16   gr_what_bg(void);
// INT16   gr_what_fg(void);
// void    gr_wr_dot(INT16 x,INT16 y);
// void    gr_wr_dot_c(INT16 x,INT16 y,INT16 color);
// void    putpt_CGA_320_200(INT16 col,INT16 row,UCHAR color);
// void    putpt_CGA_640_200(INT16 col,INT16 row,UCHAR color);


//      MSC library extentions
#define RGB(r,g,b)      ((((long)(b)<<16) & 0x3F0000) | (((long)(g)<<8) & 0x3F00) | ((long)(r) & 0x3F))

#endif  // avoid duplicate definition
