//<t>   Header File for Linked Lists

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_LLIST_H_
#define _DEFD_GD_LLIST_H_ 1


struct  D_LINKED_LIST_STRING_                   // doubly linked list
{
        STRING  s ;                             // string pointer
        int     n ;                             // sequence number in list
        struct  D_LINKED_LIST_STRING_ *prev, *next;
};
typedef struct D_LINKED_LIST_STRING_ dllist_t ;


struct  POPUP_PICKLIST_FROM_DL_LIST_            // picklist from doubly linked list
{
        STRING   title ;                        // name of picklist
        dllist_t *llTOB ;                       // entry @ top of box
        dllist_t *llBOB ;                       // entry @ bottom of box
        dllist_t *llCUR ;                       // entry highlighted
        BOOL     all_data_on_screen ;           // does all data fit on one screen?
        int      line_width ;                   // width of an entry
        int      lines_on_screen ;              // number of data lines actually shown on screen
        RC       btrow, bbrow, blcol, brcol ;   // box coordinates
        RC       trow, brow, lcol, rcol ;       // data coordinates
        RC       curln ;                        // current line within the box (1..lines_on_screen)
        int      maxlines ;                     // maximum # of data lines
        COL      fg, bg, bfg, bbg, hfg, hbg ;   // colours for normal, border, highlight
        UCHAR    *ss ;                          // to save screen
};
typedef struct POPUP_PICKLIST_FROM_DL_LIST_ picklist_t ;


extern  dllist_t *llFirst,                      // very first entry in list
                 *llLast,                       // last entry in list
                 *llCurrent,                    // current entry
                 *llPrev ;                      // previous entry [aka current->prev]
extern  int     llEntries ;                     // entries in the list
extern  int     llSeqNum ;                      // sequence number in list


// int     dll_create_entry(STRING data);          // append a list entry
// int     dll_create_sorted(STRING data);         // add to list-sorted
// void    dll_init_list(void);                    // initialize the list
// STRING  dll_picklist(int mnuwid,int lines_on_scr,STRING title,char *pickerhelp[]);
// void    dll_picklist_init(int mnuwid,int lines_on_scr,STRING title);
// void    dll_print_list(void);                   // print all entries in list
// void    dll_remove_list(void);                  // free the list


#endif  // avoid duplicate definition
