//<t>   Definitions for Menus

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_MENU_H_
#define _DEFD_GD_MENU_H_ 1


//      Definitions

#define M_ITEM_ struct menu_entry_      // Abbreviation
M_ITEM_
{
        RC      row  ;                  // row to display text
        RC      col  ;                  // column to display text
        STRING  prmt ;                  // prompt to display
        STRING  msg  ;                  // message to display
};
#define MI_MAX_ENTRIES_ 32              // maximum menu item entries


#define UNDEF           (-1)            // undefined things (row, col)
#define CUSTOM_MENU     1               // Custom: user does everything
#define SLASH_MENU      2               // Lotus 123-like menu
#define PULL_MENU       3               // Pulldown menu
#define POP_MENU        4               // Popup menu


//      Externals

extern  video_control_t vid ;                   // video control structure


//      Prototypes
// INT16   sc_menu_choice(INT16 initial_resp,UCHAR **resp_str);
// INT16   sc_menu_init(INT16 row,INT16 col,INT16 type,STRING title,INT16 boxtype,INT16 res_after,INT16 auto_ret);
// INT16   sc_menu_item(INT16 row,INT16 col,STRING prompt,STRING msg);


#endif  // avoid duplicate definition
