//<t>   Define Memory Model (Small, Compact, or Large), and Compiler

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_MODEL_H_
#define _DEFD_GD_MODEL_H_ 1


#define MUST_BE_PORTABLE 1
#define MSC     1                       //  Microsoft C
#define MSC300  1                       //  MSC v3.00+
#define MSC5    1                       //  MSC v5.00+
#define TC15    0                       //  no TURBO C 1.5+

#if     (defined(M_I86SM))
#define SMALL_MODEL     1
#define COMPACT_MODEL   0
#define LARGE_MODEL     0
#define LPROG           0
#define LDATA           0
#define SPROG           1               //  Small code model
#define SDATA           1               //  Small data model
#endif

#if     (defined(M_I86CM))
#define SMALL_MODEL     0
#define COMPACT_MODEL   1
#define LARGE_MODEL     0
#define LPROG           0
#define LDATA           1               //  Large data model
#define SPROG           1               //  Small code model
#define SDATA           0
#endif

#if     (defined(M_I86LM))
#define SMALL_MODEL     0
#define COMPACT_MODEL   0
#define LARGE_MODEL     1
#define LPROG           1               //  Large code model
#define LDATA           1               //  Large data model
#define SPROG           0
#define SDATA           0
#endif


#if LDATA
    #define     FAR_MEM         __far
#else
    #define     FAR_MEM
#endif


#if     !(defined(SMALL_MODEL))
#error  Invalid memory model
#endif


#endif  // avoid duplicate definition
