//<t>   Standard printer definition structure

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_PRT_H_
#define _DEFD_GD_PRT_H_ 1


extern  INT16   lpt_mode_, curr_lpt_, lpt_stat_ ;  // defined in pr_base.c


#define MAX_STD_PRT_L1          21
#define MAX_STD_PRT_L2          41
#define PRT_DEF                 struct  std_printer_info
PRT_DEF
{
        UCHAR   printer_name    [MAX_STD_PRT_L1] ;
        UCHAR   emph_on         [MAX_STD_PRT_L1] ;
        UCHAR   emph_of         [MAX_STD_PRT_L1] ;
        UCHAR   doub_on         [MAX_STD_PRT_L1] ;
        UCHAR   doub_of         [MAX_STD_PRT_L1] ;
        UCHAR   comp_on         [MAX_STD_PRT_L1] ;
        UCHAR   comp_of         [MAX_STD_PRT_L1] ;
        UCHAR   wide_on         [MAX_STD_PRT_L1] ;
        UCHAR   wide_of         [MAX_STD_PRT_L1] ;
        UCHAR   unln_on         [MAX_STD_PRT_L1] ;
        UCHAR   unln_of         [MAX_STD_PRT_L1] ;
        UCHAR   ff              [MAX_STD_PRT_L1] ;      //  formfeed, e.g. \012 (blank if none)
        UCHAR   init_080_mode   [MAX_STD_PRT_L2] ;
        UCHAR   exit_080_mode   [MAX_STD_PRT_L2] ;
        UCHAR   init_132_mode   [MAX_STD_PRT_L2] ;
        UCHAR   exit_132_mode   [MAX_STD_PRT_L2] ;
        UCHAR   init_000_mode   [MAX_STD_PRT_L2] ;
        UCHAR   exit_000_mode   [MAX_STD_PRT_L2] ;
        UCHAR   mode            ;                       //  0=BIOS, 1=DOS
        UCHAR   par_port        ;                       //  0,1,2 for BIOS; 0 for DOS
        BOOL    ext_ascii       ;
        INT16   page_len        ;
        INT16   page_max        ;
        INT16   line_len        ;
        INT16   line_max        ;
        INT16   eor             ;                       //  end-of-record
};


// void    init_pr_def_str(void);
// void    name_of_pr_def_file(STRING cfg_file_name);
// INT16   path_pr_def_file(STRING name,STRING path);
// INT16   read_pr_def_file(void);
// INT16   write_pr_def_file(void);
//
// INT16   pr_Char(UCHAR ch);
// INT16   pr_char_(UCHAR ch);
// INT16   pr_Codes(STRING s,INT16 n);
// BOOL    pr_dos(STRING prt_line,...);
// void    pr_dos_char(UCHAR ch);
// BOOL    pr_dos_close_printer(void);
// void    pr_dos_codes(STRING s,INT16 n);
// BOOL    pr_dos_open_printer(void);
// STRING  pr_dos_printer_name(void);
// void    pr_dos_string(STRING s);
// BOOL    pr_dos_w_xlate(STRING str);
// INT16   pr_Graphics(INT16 density,INT16 length,UCHAR *bit_table);
// INT16   pr_Header(INT16 page_width,INT16 *page_num,UCHAR *title,UCHAR *rh_line_1,UCHAR *rh_line_2,INT16 space_before,INT16 space_after);
// void    pr_lpt_(INT16 number);
// void    pr_mode_(INT16 mode);
// INT16   pr_ok_(void);
// void    pr_reset_(INT16 number);
// INT16   pr_SetupPrint(STRING str);
// BOOL    pr_SetupXlate(STRING string_in,STRING string_out,INT16 *count);
// INT16   pr_status_(void);
// int     pr_str(UCHAR *str);
// INT16   pr_String(STRING s);


#endif  // avoid duplicate definition
